#ifndef _WIN_H_
#define _WIN_H_

char *setWin(int X, int Y, int width, int height, int sep, char color, char *title)
{
 int x, y, /*X, Y,*/ X2, Y2, ok=1;

/* X=winCols/2-width/2;
 Y=(winRows+2)/2-height/2;*/

 X2 = X + width;
 Y2 = Y + height;
 char *tmp2, *tmp3, *tmp4;

 tmp2 = (char*) malloc((X2-X+3) * (Y2-Y+2) * 2);
 if (!tmp2) {ok = 0; goto drawwin;}
 tmp3 = (char*) malloc(2 * (Y2-Y+2) * 2);
 if (!tmp3) {ok = 0; free(tmp2); goto drawwin;}
 tmp4 = (char*) malloc((X2-X+1) * 2);
 if (!tmp4) {ok = 0; free(tmp2); free(tmp3); goto drawwin;}

 window(X, Y, X2, Y2);
 gettext(X, Y, X2+2, Y2+1, tmp2);

 gettext(X2+1, Y+1, X2+2, Y2+1, tmp3);
 for (x=0;x<height*2+4;x++)
   tmp3[x*2+1]&=7;
 puttext(X2+1, Y+1, X2+2, Y2+1, tmp3);
 free(tmp3);

 gettext(X+1, Y2+1, X2+1, Y2+1, tmp4);
 for (x=0;x<width;x++)
   tmp4[x*2+1]&=7;
 puttext(X+1, Y2+1, X2+1, Y2+1, tmp4);
 free(tmp4);

 drawwin:
 textattr(color);
 _wscroll = 1;
 clrscr();
 window(X, Y, X2 + 1, Y2 + 1);
 gotoxy(2,1);
 for (x = 1; x < width; x++) cputs("");
 gotoxy(2, Y2 - Y + 1);
 for (x = 1; x < width; x++) cputs("");
 gotoxy(1, 2);
 for (y = 1; y < height; y++) cputs("\010\n");
 gotoxy(X2 - X + 1, 2);
 for (y = 1; y < height; y++) cputs("\010\n");
 gotoxy(1,       1       ); cputs("");
 gotoxy(1,       height+1); cputs("");
 gotoxy(width+1, 1       ); cputs("");
 gotoxy(width+1, height+1); cputs("");
 if (sep)
 { gotoxy(2, sep);
   for (x = 1 ; x < width ; x++) cputs("");
   gotoxy(1,       sep); cputs("");
   gotoxy(width+1, sep); cputs("");
 }
 window(X, Y, X2, Y2);

 textattr(((color & 0xF0) >> 4) + ((color & 0x0F) << 4));
 gotoxy(width / 2 - strlen(title) / 2 + 2, 1);
 cputs(title);
 textattr(color);
 if (!ok) return NULL;
 else     return tmp2;

}

#endif
